#include<stdio.h>
#include<stdlib.h>

typedef struct _spekula{
    int proizvodac;
    struct _spekula *next;
}spekula;


typedef struct _spekula1{
    int proizvodac;
    int broj;
    struct _spekula1 *next;
}spekula1;

void dodaj(spekula **first, spekula **last, spekula* nova){
    if((*first) == NULL){
        (*first) = nova;
        (*last) = nova;
    }
    else{
        (*last)->next = nova;
        (*last) = (*last)->next;
    }

     nova->next = NULL;
}

void ispisi(spekula *first){
    while(first!=NULL){
        printf("%d ",first->proizvodac);
        first = first->next;
    }
    printf("\n");
}

void dodaj1(spekula1 **first, spekula1 **last, spekula1* nova){
    if((*first) == NULL){
        (*first) = nova;
        (*last) = nova;
    }
    else{
        (*last)->next = nova;
        (*last) = (*last)->next;
    }

     nova->next = NULL;
}

int pronadi(spekula1 *first, spekula *spek, spekula1 **pronadjeni){
    while(first!=NULL){
        if(first->proizvodac == spek->proizvodac){
                *pronadjeni = first;
            return 1;
        }
        first = first->next;
    }
    pronadjeni = NULL;
    return 0;
}

void broji(spekula *first, spekula1 **firstC, spekula1 **last ){

    while(first!=NULL){
        spekula1 *kandidat;
        int postoji = pronadi(*firstC,first, &kandidat);
        if(postoji == 1){
            kandidat->broj++;
        }
        else{
            kandidat = (spekula1*) malloc (sizeof(spekula1));
            kandidat->proizvodac = first->proizvodac;
            kandidat->broj = 1;
            if((*firstC)==NULL){
                (*firstC) = kandidat;
                (*last) = kandidat;
            }
            else{
            (*last)->next = kandidat;
            (*last) = (*last)->next;
            }
        }
        first = first->next;
    }
}

void ispisi1(spekula1 *first){
    while(first!=NULL){
        printf("(%d %d)",first->proizvodac, first->broj);
        first = first->next;
    }
    printf("\n");
}

spekula1* merge(spekula1 *first_1, spekula1* first_2){
    spekula1* first = NULL, *last, *pom;

    if(first_1 == NULL) return first_2;
    if(first_2 == NULL) return first_1;

    while(first_1!=NULL && first_2!=NULL){
        if(first_1->broj>=first_2->broj){
            pom = first_1;
            first_1 = first_1->next;
        }
        else{
            pom = first_2;
            first_2 = first_2->next;
        }
        if(first == NULL)
            first = pom;
        else last->next = pom;
        last = pom;
    }

    if(first_1 == NULL) last->next = first_2;
    if(first_2 == NULL) last->next = first_1;

    return first;
}

spekula1* merge_sort(spekula1 *first){
    spekula1 *last, *first_2;

    if(first == NULL || first->next == NULL){
        return first;
    }

    last = first;
    first_2 = first->next;

    while((first_2!=NULL) && (first_2->next !=NULL)){
        last = last->next;
        first_2 = first_2->next->next;
    }

    first_2 = last->next;
    last->next = NULL;

    first = merge(merge_sort(first),merge_sort(first_2));

    return first;

}

int main(void){

spekula *first = NULL, *last = NULL;
spekula *nova = NULL;
for(int i=0;i<100000;i++){
    nova = (spekula*) malloc (sizeof(spekula));
    nova->proizvodac = rand()%100;
    dodaj(&first, &last,nova);
}

ispisi(first);

printf("\n\n");
spekula1 *first1 = NULL, *last1 = NULL;
broji(first,&first1,&last1);
ispisi1(first1);


first1 = merge_sort(first1);
ispisi1(first1);


spekula *pom1, *pom2= first;
for(pom1 = first; pom2!=NULL;pom1 = pom2){
    pom2 = pom1->next;
    free(pom1);
}

spekula1 *pom3, *pom4= first1;
for(pom3 = first1; pom4!=NULL;pom3 = pom4){
    pom4 = pom3->next;
    free(pom3);
}

return 0;
}
