#include<stdio.h>
#include<stdlib.h>

typedef struct _balon{
    int boja;
    struct _balon *next;
}balon;


typedef struct _balon1{
    int boja;
    int broj;
    struct _balon1 *next;
}balon1;

void dodaj(balon **first, balon **last, balon* novi){
    if((*first) == NULL){
        (*first) = novi;
        (*last) = novi;
    }
    else{
        (*last)->next = novi;
        (*last) = (*last)->next;
    }

     novi->next = NULL;
}

void ispisi(balon *first){
    while(first!=NULL){
        printf("%d ",first->boja);
        first = first->next;
    }
    printf("\n");
}

void dodaj1(balon1 **first, balon1 **last, balon1* novi){
    if((*first) == NULL){
        (*first) = novi;
        (*last) = novi;
    }
    else{
        (*last)->next = novi;
        (*last) = (*last)->next;
    }

     novi->next = NULL;
}

int pronadi(balon1 *first, balon *bal, balon1 **pronadjeni){
    while(first!=NULL){
        if(first->boja == bal->boja){
                *pronadjeni = first;
            return 1;
        }
        first = first->next;
    }
    pronadjeni = NULL;
    return 0;
}

void broji(balon *first, balon1 **firstC, balon1 **last ){

    while(first!=NULL){
        balon1 *kandidat;
        int postoji = pronadi(*firstC,first, &kandidat);
        if(postoji == 1){
            kandidat->broj++;
        }
        else{
            kandidat = (balon1*) malloc (sizeof(balon1));
            kandidat->boja = first->boja;
            kandidat->broj = 1;
            if((*firstC)==NULL){
                (*firstC) = kandidat;
                (*last) = kandidat;
            }
            else{
            (*last)->next = kandidat;
            (*last) = (*last)->next;
            }
        }
        first = first->next;
    }
}

void ispisi1(balon1 *first){
    while(first!=NULL){
        printf("(%d %d)",first->boja, first->broj);
        first = first->next;
    }
    printf("\n");
}

balon1* merge(balon1 *first_1, balon1* first_2){
    balon1* first = NULL, *last, *pom;

    if(first_1 == NULL) return first_2;
    if(first_2 == NULL) return first_1;

    while(first_1!=NULL && first_2!=NULL){
        if(first_1->broj<=first_2->broj){
            pom = first_1;
            first_1 = first_1->next;
        }
        else{
            pom = first_2;
            first_2 = first_2->next;
        }
        if(first == NULL)
            first = pom;
        else last->next = pom;
        last = pom;
    }

    if(first_1 == NULL) last->next = first_2;
    if(first_2 == NULL) last->next = first_1;

    return first;
}

balon1* merge_sort(balon1 *first){
    balon1 *last, *first_2;

    if(first == NULL || first->next == NULL){
        return first;
    }

    last = first;
    first_2 = first->next;

    while((first_2!=NULL) && (first_2->next !=NULL)){
        last = last->next;
        first_2 = first_2->next->next;
    }

    first_2 = last->next;
    last->next = NULL;

    first = merge(merge_sort(first),merge_sort(first_2));

    return first;

}

int main(void){

balon *first = NULL, *last = NULL;
balon *novi = NULL;
for(int i=0;i<100000;i++){
    novi = (balon*) malloc (sizeof(balon));
    novi->boja = rand()%10;
    dodaj(&first, &last,novi);
}

ispisi(first);

printf("\n\n");
balon1 *first1 = NULL, *last1 = NULL;
broji(first,&first1,&last1);
ispisi1(first1);


first1 = merge_sort(first1);
ispisi1(first1);


balon *pom1, *pom2= first;
for(pom1 = first; pom2!=NULL;pom1 = pom2){
    pom2 = pom1->next;
    free(pom1);
}

balon1 *pom3, *pom4= first1;
for(pom3 = first1; pom4!=NULL;pom3 = pom4){
    pom4 = pom3->next;
    free(pom3);
}

return 0;
}
