#include<stdio.h>
#include<stdlib.h>

//(a) podzadatak

int** sifriraj(char** rijeci, int n, int k){
    int i, j, m;

    //dinamicki alociramo n x n
    //matricu cijelih brojeva
    int **matrica;
    matrica = (int**)malloc(n * sizeof(int*));
    for(i = 0; i < n; ++i)
        matrica[i] = (int*)malloc(n * sizeof(int));

    //moglo se alocirati (tada uz obaveznu dealokaciju!)
    //matrica n x n charova i onda tek upisivati u
    //matricu intova brojeve dobivene iz njih, no to
    //cemo ovdje spojiti u jedan korak

    for(i = 0; i < n; ++i){
        for(j = 0; rijeci[i][j] != '\0'; ++j)
            matrica[i][j] = rijeci[i][j] - 'a' + 1;

        //ostalo (ako ostalo mjesta) je r. br. od 'x'
        for(   ; j < n; ++j)
            matrica[i][j] = 'x' - 'a' + 1;
    }

    //rijesili korake 1. i 3.
    //sad korak 2. (pomicanje - 4. korak ovisi o tome)
    for(i = 0; i < n; ++i){
        //blokovi idu od 1 do n/k; tada m-ti blok
        //"ima" stupce od (m-1)*k do m*k-1
        for(m = 1; m <= n/k; ++m){
            if(i % 2 == 0){ //parni red => udesno za 1
                int temp = matrica[i][m*k-1];
                for(j = m*k-1; j > (m-1)*k; --j)
                    matrica[i][j] = matrica[i][j-1];
                matrica[i][(m-1)*k] = temp;
            } else {    //neparni red => ulijevo za 1
                int temp = matrica[i][(m-1)*k];
                for(j = (m-1)*k; j < m*k-1; ++j)
                    matrica[i][j] = matrica[i][j+1];
                matrica[i][m*k-1] = temp;
            }
        }
    }

    //4. korak - kvadriranje na glavnoj i sporednoj dijag.
    for(i = 0; i < n; ++i)
        for(j = 0; j < n; ++j)
            if(i == j || i + j == n - 1)
                matrica[i][j] *= matrica[i][j];

    //ne smijemo dealocirati matricu jer moramo to vratiti,
    //no ako je bilo koje drugo polje alocirano prije return
    //mora biti dealocirano!
    return matrica;
}

//pomocna funkcija koja vraca korijen broja n
//(ili 0 ako n nije kvadrat prirodnog broja)
int kvadrat(int n){
    int i;
    for(i = 1; i <= n; ++i)
        if(i * i == n)
            return i;
    return 0;
}


//(b) podzadatak

int main(void){
    int i, j, m, n;
    FILE* in = fopen("sifrata.dat","rb");

    fread(&n, sizeof(int), 1, in);

    int sifrirana = 1, broj;
    for(i = 0; i < n; ++i){
        for(j = 0; j < n; ++j){
            fread(&broj, sizeof(int), 1, in);
            if(i == j || i + j == n - 1){
                if(kvadrat(broj) < 1 || kvadrat(broj) > 26)
                    sifrirana = 0;
            } else if(broj < 1 || broj > 26)
                    sifrirana = 0;
        }
    }

    if(sifrirana == 1)
        printf("DA");
    else
        printf("NE");

    fclose(in);

    return 0;
}
