#include<stdio.h>
#include<stdlib.h>

//(a) podzadatak

char** desifriraj(int** sifrirano, int n){
    int i, j, k;

    //odredimo korijene elemenata na gl. ili sp. dijagonali
    for(i = 0; i < n; ++i){
        for(j = 0; j < n; ++j){
            if(i == j || i + j == n - 1) //na gl. ili sp. dijagonali
               for(k = 0; k <= sifrirano[i][j]; ++k)
                    if(k * k == sifrirano[i][j]){
                        sifrirano[i][j] = k;
                        break;
                    }
        }
    }

    for(i = 0; i < n; ++i){
        //radimo pomicanje u i-tom retku
        if(i % 2 == 0){ //parni udesno dok 0 nije na sp. dijag.
            while(sifrirano[i][n-1-i] != 0){
                //pomicemo za 1 udesno
                int temp = sifrirano[i][n-1];
                for(j = n - 1; j > 0; --j)
                    sifrirano[i][j] = sifrirano[i][j-1];
                sifrirano[i][0] = temp;
            }
        } else { //neparni ulijevo dok 0 nije na gl. dijagonali
            while(sifrirano[i][i] != 0){
                //pomicemo za 1 ulijevo
                int temp = sifrirano[i][0];
                for(j = 0; j < n-1; ++j)
                    sifrirano[i][j] = sifrirano[i][j+1];
                sifrirano[i][n-1] = temp;
            }
        }
    }

    //zamjena brojeva slovima - to cemo spojiti sa zadnjim korakom

    //alokacija za n+1 string; kako je u svakom retku tocno
    //jedna praznina (tj. 0) mozemo kao gornju ogradu za
    //pojedini string staviti 2*n
    char** poruka = (char**)malloc((n+1) * sizeof(char*));
    for(i = 0; i < n + 1; ++i)
        poruka[i] = (char*)malloc(2*n*sizeof(char));

    //koju rijec trenutno popunjavamo i koje slovo u toj rijeci
    int br_rijeci = 0, br_slova = 0;

    for(i = 0; i < n; ++i){
        if(i % 2 == 0){ //parne retke citamo slijeva nadesno
            for(j = 0; j < n; ++j){
                if(sifrirano[i][j] == 0){ //pocinje nova rijec
                    poruka[br_rijeci][br_slova] = '\0';
                    br_rijeci++;
                    br_slova = 0;
                } else {
                    poruka[br_rijeci][br_slova] = 'a' + sifrirano[i][j] - 1;
                    br_slova++;
                }
            }
        } else { //neparne retke citamo zdesna nalijevo
            for(j = n - 1; j >= 0; --j){
                if(sifrirano[i][j] == 0){ //pocinje nova rijec
                    poruka[br_rijeci][br_slova] = '\0';
                    br_rijeci++;
                    br_slova = 0;
                } else {
                    poruka[br_rijeci][br_slova] = 'a' + sifrirano[i][j] - 1;
                    br_slova++;
                }
            }
        }
    }

    //na kraju zadnje rijeci treba staviti jos '\0'
    //(moze se uociti i na primjeru u zadatku)
    poruka[br_rijeci][br_slova] = '\0';

    return poruka;
}

//pomocna funkcija koja vraca korijen neneg. broja n
//(ili -1 ako n nije kvadrat nenegativnog broja)
int kvadrat(int n){
    int i;
    for(i = 0; i <= n; ++i)
        if(i * i == n)
            return i;
    return -1;
}


//(b) podzadatak

int main(void){
    FILE* in = fopen("sifratb.dat","rb");

    int n, i, j;
    fread(&n,sizeof(int),1,in);

    int sifrirana = 1, broj;
    for(i = 0; i < n; ++i){
        //treba usput provjeriti je li tocno jedna 0 u retku
        int br_nula = 0;
        for(j = 0; j < n; ++j){
            fread(&broj, sizeof(int), 1, in);
            if(i == j || i + j == n - 1){
                if(kvadrat(broj) == -1 || kvadrat(broj) > 26)
                    sifrirana = 0;
            } else if(broj < 0 || broj > 26)
                    sifrirana = 0;
            if(broj == 0)
                br_nula++;
        }
        if(br_nula != 1)
            sifrirana = 0;
    }

    if(sifrirana == 1)
        printf("DA");
    else
        printf("NE");

    fclose(in);

    return 0;
}
